/**
   BasicHTTPClient.ino

    Created on: 24.05.2015

*/

#include <Arduino.h>
#include <ABB_B23.h>              //import ABB_B23 library

#include <ESP8266WiFi.h>
#include <ESP8266WiFiMulti.h>

#include <ESP8266HTTPClient.h>

#include <WiFiClient.h>

ESP8266WiFiMulti WiFiMulti;

#if defined ( USE_HARDWARESERIAL )                                                  //for HWSERIAL
    ABB_B23 ABB_B23(Serial, ABB_B23_UART_BAUD, DERE_PIN, ABB_B23_UART_CONFIG);      //config ABB_B23
#endif

void setup() {
  ABB_B23.begin();              //initialize ABB_B23 communication
  WiFi.mode(WIFI_STA);
  WiFiMulti.addAP("SSID", "PASSWORT");

}

void loop() {
    float U_L1 = ABB_B23.readVal(ABB_U_LN_P1, 2);
    float U_L2 = ABB_B23.readVal(ABB_U_LN_P2, 2);
    float U_L3 = ABB_B23.readVal(ABB_U_LN_P3, 2);
    float U_L12 = ABB_B23.readVal(ABB_U_LL_P12, 2);
    float U_L23 = ABB_B23.readVal(ABB_U_LL_P23, 2);
    float U_L31 = ABB_B23.readVal(ABB_U_LL_P31, 2);
    float I_L1 = ABB_B23.readVal(ABB_I_P1, 2);
    float I_L2 = ABB_B23.readVal(ABB_I_P2, 2);
    float I_L3 = ABB_B23.readVal(ABB_I_P3, 2);
    float P = ABB_B23.readVal(ABB_P_SYSTEM, 2);
    float P_L1 = ABB_B23.readVal(ABB_P_P1, 2);         //P_P1
    float P_L2 = ABB_B23.readVal(ABB_P_P2, 2);         //P_P2
    float P_L3 = ABB_B23.readVal(ABB_P_P3, 2);         //P_P3
    float F = ABB_B23.readVal(ABB_F, 1);         //F
    float P_total = ABB_B23.readVal(ABB_IMPORT_P, 4);   //Total active kWh
    yield();
  // wait for WiFi connection
  if ((WiFiMulti.run() == WL_CONNECTED)) {
    WiFiClient client;
    HTTPClient http;
    Serial.print("[HTTP] begin...\n");
    if (http.begin(client, "http://10.0.0.10/gateway.php?U_L1="+String(U_L1)+"&U_L2="+String(U_L2)+"&U_L3="+String(U_L3)+"&U_L12="+String(U_L12)+"&U_L23="+String(U_L23)+"&U_L31="+String(U_L31)+"&I_L1="+String(I_L1)+"&I_L2="+String(I_L2)+"&I_L3="+String(I_L3)+"&P="+String(P)+"&P_L1="+String(P_L1)+"&P_L2="+String(P_L2)+"&P_L3="+String(P_L3)+"&F="+String(F)+"&P_total="+String(P_total))){
      // start connection and send HTTP header
      int httpCode = http.GET();
      // httpCode will be negative on error
      if (httpCode > 0) {
        // HTTP header has been send and Server response header has been handled
        Serial.printf("[HTTP] GET... code: %d\n", httpCode);
        // file found at server
        if (httpCode == HTTP_CODE_OK || httpCode == HTTP_CODE_MOVED_PERMANENTLY) {
          String payload = http.getString();
          Serial.println(payload);
        }
      } else {
        Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
      }
      http.end();
    } else {
      Serial.printf("[HTTP} Unable to connect\n");
    }
  }

  delay(10000);
}
